﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class UsefulCoupleCG : CandidatesGenerator
	{
		bool big, all;

		public UsefulCoupleCG(bool all) : this(all, true)
		{ }

		public UsefulCoupleCG(bool all, bool big)
		{
			this.big = big;
			this.all = all;
		}

		protected override ThreadSafeQueue<Community> generate(ThreadSafeQueue<Community> queue)
		{
			HashSet<int> seen = new HashSet<int>();
			for (int i = 0; i < size; i++)
			{
				if (!all && seen.Contains(i))
					continue;
				seen.Add(i);

				foreach (int j in graph.getNeighbours(i))
				{
					if (!all && seen.Contains(j) && !big)
						continue;
					seen.Add(j);

					Community c = new Community(graph);
					c.AddVertice(i);
					c.AddVertice(j);
					queue.Enqueue(c);
				}
			}
			return queue;
		}

		public override string ToString()
		{
			return base.ToString() + (all ? " - All" : (" - Not all - "+(big?"Big":"Small")));
		}

		public override string abbr()
		{
			return "uc"+(all?"A":(big?"B":"S"))+"-" + (smartStart ? "y" : "n");
		}
	}
}
