﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
    public class BinaryMatrixBitArrays : BinaryMatrix
    {
		//ok
        protected BitArray[] data;

		//ok
        public BinaryMatrixBitArrays(int m, int n)
        {
            this.m = m;
            this.n = n;
            data = new BitArray[m];
			for (int i = 0; i < m; i++)
				data[i] = new BitArray(n);
        }


		public BinaryMatrixBitArrays(string file)
		{
			StreamReader reader = new StreamReader(file);
			string line = null;
			while (line == null || line[0] == '#' || line[0] == '%')
				line = reader.ReadLine();
			m = int.Parse(line);
			n = int.Parse(reader.ReadLine());

			data = new BitArray[int.Parse(reader.ReadLine())];
			int size = int.Parse(reader.ReadLine());
			

			int type = int.Parse(reader.ReadLine());
			int i = 0;
			while(null != (line = reader.ReadLine()))
			{
				int[] rowdata = new int[size];
				string[] words=line.Split(' ');
				for(int j=0; j<size; j++)
				{
					rowdata[j] = Convert.ToInt32(words[j], type);
				}
				data[i] = new BitArray(rowdata, n);
				i++;
			}
			reader.Close();
		}


		//ok
		public override BitArray getRow(int i)
		{
			return data[i];
		}

		//ok
		public override bool get(int i, int j)
        {
            return data[i].get(j);
        }

		public override int[] columnSum()
		{
			int[] sum = new int[n];
			for (int i = 0; i < m; i++)
			{
				int[] row = data[i].Data;
				for (int j = 0; j < row.Length; j++)
				{
					if (row[j] != 0)
					{
						for (int k = j * 32; k < (j + 1) * 32 && k < n  ; k++)
						{
							if (get(i, k))
							{
								sum[k]++;
							}
						}
					}
				}
			}
			return sum;
		}

		//ok
		public override int countValue(bool v)
		{
			int count=0;
			for (int i = 0; i < m; i++)
			{
				count += data[i].countValue(v);
			}
			return count;
		}

		public override List<int> getIndexesByValuePerRow(int i, bool v)
		{
			return data[i].getIndexsByValue(v);
		}

		//ok
		public override int countRow(int i, bool v)
		{
			return data[i].countValue(v);
		}

		//ok
		public override void set(int i, int j, bool v)
        {
			data[i].set(j, v);
		}

        protected override void print(TextWriter writer, int type)
        {
			int b = (type == 16) ? 16 : (type == 10 ? 10 : 2);

			//info
			writer.WriteLine("##### Matrix file ######");
			writer.WriteLine("# Size:");
			writer.WriteLine("#     m: " + m);
			writer.WriteLine("#     n: " + n);
			writer.WriteLine("# Encoding:");
			writer.WriteLine("#  base: " + b);
			writer.WriteLine("###### data ######");

			//parse info
			writer.WriteLine(m);
			writer.WriteLine(n);
			writer.WriteLine(data.Length);
			writer.WriteLine(data[0].Data.Length);
			writer.WriteLine(b);

			//data
			for (int i = 0; i < data.Length; i++)
			{
				int[] rowdata = data[i].Data;
				for (int j = 0; j < rowdata.Length; j++)
				{
					if (j > 0)
						writer.Write(" ");
					writer.Write(format(rowdata[j],b));
				}
				if (i < data.Length - 1)
					writer.WriteLine();
			}
        }
    }
}
