﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public abstract class BitClass
	{
		protected int n;

		public int N
		{
			get
			{
				return n;
			}
		}

		public int NumberOfSetBits(int i)
		{
			i = i - ((i >> 1) & 0x55555555);
			i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
			return (((i + (i >> 4)) & 0x0F0F0F0F) * 0x01010101) >> 24;
		}

		protected string format(int n, int b)
		{
			switch (b)
			{
				case 10:
					return Convert.ToString(n, 10);
				case 16:
					return Convert.ToString(n, 16).PadLeft(8, '0');
				default:
					return Convert.ToString(n, 2).PadLeft(32, '0');
			}
		}

	}
}
