﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace CommunityDetection
{
	abstract class FileTypeReader <T>
	{
		string file;
		StreamReader reader; 

		public FileTypeReader(string file)
		{
			this.file = file;
			reader = new StreamReader(file);
		}

		public T read()
		{
			T obj = createEmptyObject();

			String line;
			int count = 0;
			while (null != (line = reader.ReadLine()))
			{
				readLine(line, obj, count++);
			}
			reader.Close();
			return obj;
		}
		public abstract void readLine(String line, T obj, int count);
		public abstract T createEmptyObject();

	}
}
