﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CommunityDetection;

namespace CommunityDetection
{
	abstract public class QualityMeasure
	{

		public abstract double communityGain(Community c);

		public abstract double gain(Community c, int v, bool add);

		/**
		 * Return the number of internal errors in the case v in C
		 */
		public int errw(Community c, int v)
		{
			Dictionary<int, int> vertices = c.getVertices();
			Dictionary<int, int> neighbours = c.getNeighbours();

			if (vertices.ContainsKey(v))
				return vertices.Count - vertices[v] - 1;
			if (neighbours.ContainsKey(v))
				return c.Size - neighbours[v];
			return c.Size;
		}

		/** Debug methods **/
		public void calc(Community own, int v)
		{
			UndirectedGraph graph = own.getGraph();
			bool add = !own.getVertices().ContainsKey(v);
			Console.WriteLine("--- " + (add ? "Add" : "Remove") + " " + v + " ---");
			Console.WriteLine("internal errors for v: " + errw(own, v)); 
			Console.WriteLine("original :");
			Console.WriteLine("  "+own);
			Console.WriteLine("after: ");
			Community c = new Community(graph);
			foreach (int u in own.getVertices().Keys)
			{
				if (add || u != v)
					c.AddVertice(u);
			}
			if (add)
				c.AddVertice(v);
			Console.WriteLine("  "+c);
			Console.WriteLine("internal errors for v: " + errw(c ,v));
			Console.WriteLine("Gain:");

			//goed
			double eg = gain(own, v, add);
			double rg = communityGain(c) - communityGain(own);
			Console.WriteLine(" expected:" + eg);
			Console.WriteLine(" real: " + rg);
			Console.WriteLine(" equal: " + (eg == rg ? "OKAY" : "WRONG"));
		}
	}
}
