﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace CommunityDetection
{
	class EmRun
	{
		CommunityStampSet stampSet;
		ThreadSafeQueue<Community> input;
		ThreadSafeQueue<Community> output;

		public EmRun(CommunityStampSet stampSet, ThreadSafeQueue<Community> input, ThreadSafeQueue<Community> output)
		{
			this.stampSet = stampSet;
			this.output = output;
			this.input = input;
		}

		public void run()
		{
			bool skip;
			while (!input.Empty())
			{
				skip = false;
				try
				{
					Community c = input.Dequeue();
					if (stampSet.Contains(c))
						continue;
					stampSet.Add(c);
					while (c.improve())
					{
						if (stampSet.Contains(c))
						{
							skip = true;
							break;
						}
						stampSet.Add(c);
					}
					if(!skip)
						output.Enqueue(c);
				}
				catch (InvalidOperationException)
				{
					break;
				}
			}
		}

	}
}
